//  javascript file: homePage.js
//
//  2.15.2010 by DJL

//  new as of 6.1.2010 -
function HPlinksubmit(linkinstr) {  
	var f = document.homepage;
	f.linksubmit.value=linkinstr; // places the argument in the hidden field before form submission
	saveScrollXY() // to preserve scroll when clicking on IEP link, before leaving page
	// removes diagnostic msgs for a previous problem on the home page --
	if(document.getElementById("diagn_ID")) {  
		document.getElementById("diagn_ID").value = "";
	}
	f.submit();
	return false
}

function HP_clearSTsrchBox() {  // 1.1.2011
	if(document.getElementById('HP_stdntSrchBox')) {  
		var srchBoxValue = document.getElementById('HP_stdntSrchDrop').value;
		if(!srchBoxValue.match(/:/)) {  // there is no colon, so there should be no contents for box --
			document.getElementById('HP_stdntSrchBox').value = "";
		 }
	}
	return false
}

function HP_clearIEPsrchBox() {  // 1.1.2011
	if(document.getElementById('HP_IEPsrchBox')) {  
		var srchBoxValue = document.getElementById('HP_IEPsrchDrop').value;
		if(!srchBoxValue.match(/:/)) {  // there is no colon, so there should be no contents for box --
			document.getElementById('HP_IEPsrchBox').value = "";
		 }
	}
	return false
}

function showHmePgHlp() { 
		var web_sid = document.getElementById('web_SID').value;
		var HP_helpWin = window.open("assessment?c=display_HP_help&sid="+web_sid, "Home_page_help",
			"width=800,height=750,resizable=yes,status=yes,menubar=no,scrollbars=yes"); 
 HP_helpWin.focus(); 
}

function showCrtNavIEP(web_sid) { 
		var HP_crtNavIEP = window.open("assessment?c=display_crtNavIEP&sid="+web_sid, "Create_navigate_IEP",
			"width=600,height=400,resizable=yes,status=yes,menubar=no,scrollbars=yes"); 
 HP_crtNavIEP.focus(); 
} 	

function showFormsCloset() { 
		var web_sid = document.getElementById('web_SID').value;
		var HP_formsCloset = window.open("assessment?c=display_HP_formsCloset&sid="+web_sid, "Forms_closet",
			"width=700,height=500,resizable=yes,status=yes,menubar=yes,scrollbars=yes"); 
 HP_formsCloset.focus(); 
} 

function HPwhoIsHere() { 
		var web_sid = document.getElementById('web_SID').value;
		var HP_whoishere = window.open("assessment?c=display_HP_whoIsHere&sid="+web_sid, "Who_is_here",
			"width=700,height=500,resizable=yes,status=yes,menubar=yes,scrollbars=yes"); 
 HP_whoishere.focus(); 
} 


// The following get information on the window size and scroll position --
// Many thanks to www.softcomplex.com discussion

function f_clientWidth() {
	return f_filterResults (
		window.innerWidth ? window.innerWidth : 0,
		document.documentElement ? document.documentElement.clientWidth : 0,
		document.body ? document.body.clientWidth : 0
	);
}
function f_clientHeight() {
	return f_filterResults (
		window.innerHeight ? window.innerHeight : 0,
		document.documentElement ? document.documentElement.clientHeight : 0,
		document.body ? document.body.clientHeight : 0
	);
}
function f_scrollLeft() {
	return f_filterResults (
		window.pageXOffset ? window.pageXOffset : 0,
		document.documentElement ? document.documentElement.scrollLeft : 0,
		document.body ? document.body.scrollLeft : 0
	);
}
function f_scrollTop() {
	return f_filterResults (
		window.pageYOffset ? window.pageYOffset : 0,
		document.documentElement ? document.documentElement.scrollTop : 0,
		document.body ? document.body.scrollTop : 0
	);
}
function f_filterResults(n_win, n_docel, n_body) {
	var n_result = n_win ? n_win : 0;
	if (n_docel && (!n_result || (n_result > n_docel)))
		n_result = n_docel;
	return n_body && (!n_result || (n_result > n_body)) ? n_body : n_result;
}

// To save the scroll position before leaving the page --

function saveScrollXY() {
	document.homepage.web_HP_scrollX.value = f_scrollLeft();
	document.homepage.web_HP_scrollY.value = f_scrollTop();
}

// To return to the previous scroll position when returning to the page --

function resetScrollPosition() {
	var hidx, hidy;
	hidx = document.homepage.web_HP_scrollX;
	hidy = document.homepage.web_HP_scrollY;
	if (typeof hidx != 'undefined' && typeof hidy != 'undefined') {
		window.scrollTo(hidx.value, hidy.value);
	}
}


function pausecomp(millis) { //to produce loop delays
	var date = new Date();
	var curDate = null;
	do { curDate = new Date(); }
	while(curDate-date < millis);
} 


// Math.random forces IE to send the Ajax request each time; otherwise there's a cache problem

function messageGetAct(host_URL, web_sid, ajaxReqType) {  // for a page with no "id" and/or no "c"
	new Ajax.Request('/'+host_URL, {
		method: 'get', 
		parameters: {c: 'AJAX_request', ajtype: ajaxReqType, sid: web_sid, rnd: Math.random()},
		onSuccess: function(response) {		
			if(response.responseText.length>0) {
				if(ajaxReqType == 'instantMessage') {
					if(response.responseText.match(/two minutes/i)) {
						var colorname = "red"; } else { var colorname = "DarkOrange";}
					if(response.responseText.match('idleRedirect')) {
						window.location = "/index.html";
							} else {
						if(!response.responseText.match('No instant msg update')) {
							winCSSinWdw("System message..", response.responseText, 400, 100, colorname);
						} // response is not "no instant msg update"
					} // 'idleRedirect' case for logoff
				} // (ajaxReqType == 'instantMessage') 
			} // non-blank response text
		}  // onSuccess
	}); //  new Ajax.Request
} // end of messageGet function




function createPickers() { 
	$(document.body).select('input.datepicker').each( 
	function(e) { 
		new Control.DatePicker(e, { 'icon': '/images/calendar.png' }); 
	}); 
} 


document.observe("dom:loaded", function() {
	createPickers();
	resetScrollPosition();
	var web_sid = document.getElementById('web_SID').value;
	var host_URL = document.getElementById('web_serverIP').value;
	new Ajax.Request('/'+host_URL, {
		method: 'get', 
		parameters: {c: 'AJAX_request', ajtype: 'pollingInterval', sid: web_sid, rnd: Math.random()},
		onSuccess: function(response) {		
			if(response.responseText.length>0) {
				var delaySecs = parseInt(response.responseText);
				if(delaySecs<20 || delaySecs>90) {delaySecs = 20;}
				// alert('delay secs is '+delaySecs);
				new PeriodicalExecuter(function(pe) {  // this runs messageGet every xx seconds
					messageGetAct(host_URL, web_sid, 'instantMessage');
				}, delaySecs);
			} // non-blank response text
		}  // onSuccess
	}); //  new Ajax.Request
});  // end of document.observe