// JavaScript Document - pgStdLoader.js

// 1.18.2011 DJL 
// For setting up date picker and AJAX message checking


function msgEntryRqst(host_URL, web_sid, pageType, recordNbr) {
	updateElapsedTime();
	var cmd = document.getElementsByName("c")[0]; // only one item NAMED "c" (command) on pg
	var proceed_B = false;
	if(window.sessionStorage) {
		if(cmd.value) {
			if((sessionStorage.getItem(cmd.value)) && (sessionStorage.getItem(cmd.value) == "posted")) {
				// in this case do not proceed, active user post underway
			} else {
				proceed_B = true;
			}
		}
	} else {  // no session storage support
		proceed_B = true;	
	}
	if(proceed_B) {
		new Ajax.Request('/'+host_URL, {
			method: 'get', 
			parameters: {c: 'AJAX_request', ajtype: 'instantMessage', sid: web_sid, pagetype: pageType, record: recordNbr, rnd: Math.random()},
			onSuccess: function(response) {	
				if(response.responseText.length>0) {
					if(response.responseText.match(/will have released/i)) 
						{var colorname = "sienna";} 
					else if(response.responseText.match(/will release/i)) 
						{var colorname = "purple";} 
					else if(response.responseText.match(/two minutes/i)) 
						{var colorname = "red";} 
					else {var colorname = "DarkOrange";} //color assignments
					if(response.responseText.match('emrgncySave')) { // shouldn't happen if page has no "record"
						var f = document.getElementsByTagName("form")[0]; // only one TAG 'form' on page						
						var proceed = false;
						if(cmd.value.match(/student_/i))
							{proceed = true;}
						else if (cmd.value.match(/assessment_/i))
							{proceed = true;}
						else if(cmd.value.match(/ATT_edit/i))
							{proceed = true;}
						else if(cmd.value.match(/DRDP_/i))
							{proceed = true;}
						if(proceed == true) {
							// alert("It's a data entry situation, we will perform a submit.");
							f.linksubmit.value = "emrgncySave";
							f.submit();
							return false;
						} // proceed = true
					} else {  //response.responseText is not "emrgncySave", must repeat code above --
							if(response.responseText.match('idleRedirect')) {
								window.location = "/index.html";
							} else {
								if(!response.responseText.match('No instant msg update')) {
									 winCSSinWdw("System message", response.responseText, 400, 100, colorname);
								} // response is not "no instant msg update"
							} // 'idleRedirect' case for logoff
					} //'emrgncySave, last ditch save attempt
				} else { // response text was blank --
					if(!warng_win.closed) {warng_win.close;}
				}  // non-blank response text
			}  // onSuccess
		}); //  new Ajax.Request
	} // proceed_B
} // end of messageGet function



function msgEntryRqst2(host_URL, web_sid) {  // for a page with no "id" and/or no "c"
	new Ajax.Request('/'+host_URL, {
		method: 'get', 
		parameters: {c: 'AJAX_request', ajtype: 'instantMessage', sid: web_sid, rnd: Math.random()},
		onSuccess: function(response) {		
			if(response.responseText.length>0) {
				if(response.responseText.match(/two minutes/i)) {
					var colorname = "red"; } else { var colorname = "DarkOrange";}
				if(response.responseText.match('idleRedirect')) {
					window.location = "/index.html";
						} else {
					if(!response.responseText.match('No instant msg update')) {
						winCSSinWdw("System message..", response.responseText, 400, 100, colorname);
						// warningdialog(response.responseText, colorname);
					} // response is not "no instant msg update"
				} // 'idleRedirect' case for logoff
			} // non-blank response text
		}  // onSuccess
	}); //  new Ajax.Request
} // end of messageGet function


function createPickers() { 
	$(document.body).select('input.datepicker').each( 
	function(e) { 
		new Control.DatePicker(e, { 'icon': '/images/calendar.png' }); 
	}); 
	$(document.body).select('input.timepicker').each( 
	function(e) { 
		new Control.DatePicker(e, { 'icon': '/images/clock.png', timePicker: true, datePicker: false, use24hrs: false }); 
	}); 
} 


function updateElapsedTime() {	
	if($("ticker_ID")) {
		var datestamp = new Date();	
		var elapsedMins = ((datestamp.getTime() - timestart)/1000)/60 // to get minutes elapsed
		$("ticker_ID").value = Math.round(elapsedMins*100)/100 // to get 2 digits after decimal
	}
	return false;
}


function startElapsedTime() {
	var datestart = new Date();		
	timestart = datestart.getTime();  // global variable
	return false;
}



document.observe("dom:loaded", function() {
	createPickers();
	startElapsedTime();
	if($("ticker_ID")) { $("ticker_ID").value = 0; }
	var web_sid = document.getElementById('web_SID').value;
	var host_URL = document.getElementById('web_serverIP').value;
	new Ajax.Request('/'+host_URL, {
		method: 'get', 
		parameters: {c: 'AJAX_request', ajtype: 'pollingInterval', sid: web_sid, rnd: Math.random()},
		onSuccess: function(response) {		
			if(response.responseText.length>0) {
				var delaySecs = parseInt(response.responseText);
				if(delaySecs<=100) { // 8.26.2013 if it is beyond 100, don't start the periodicalExecuter at all
					if(delaySecs<20) {delaySecs = 20;}  // 8.26.2013 this was "if(delaySecs<20 || delaySecs>90) {delaySecs = 20;}"
					// alert('delay secs is '+delaySecs);
					var cmdArray = document.getElementsByName('c'); // there should be only one element in the array
					var nsubmtArray = document.getElementsByName('nsubmit');	
					var postForm = 'no';
					// the form needs both a "c" and "nsubmit"-named (rather than "submit"-named) buttons,
					// the presence of "submit"-named buttons cause it not to be posted when attempted
					if(cmdArray.length > 0) {if(nsubmtArray.length>0) {postForm = 'yes';}}
					if(postForm == 'yes') { // it's a data entry form
						var pageType = cmdArray[0].value; 
						var recordNbr = document.getElementsByName('id')[0].value; // need this for web holds	
						if(window.sessionStorage) {
							sessionStorage.setItem(pageType, "");  // initially blank value this page
							document.observe('click', function(event) {
								if((event.findElement('input[type=submit]')) || (event.findElement('input[type=image]'))) {
									sessionStorage.setItem(pageType, "posted");
								}
							});  // document.observe, note this is the end of a line as an implicit function
						}  // window.sessionStorage
						new PeriodicalExecuter(function(pe) {msgEntryRqst(host_URL, web_sid, pageType, recordNbr);}, delaySecs);	
					} else {  // it's not a data entry form, just force a log off, where possible --
						new PeriodicalExecuter(function(pe) {msgEntryRqst2(host_URL, web_sid);}, delaySecs);
					} // postForm == "yes"
				}  // if(delaySecs<=100)
			} // non-blank response text
		}  // onSuccess
	}); //  new Ajax.Request
});  // end of document.observe


// the following did not work (Firefox) - window.onbeforeunload = function(){return;};